﻿-- XXX
-- Uncomment the necesary lines if you want to remark resurrected whelps too, untested tho

--------------------------------------------------------------------------------
-- Module Declaration
--

local mod = BigWigs:NewBoss("Sinestra Whelp Marker", 758)
if not mod then return end
mod:RegisterEnableMob(45213)

--------------------------------------------------------------------------------
-- Locals
--

--local spawnBreath = true
local whelps = {}
local usedMarks = {}

--------------------------------------------------------------------------------
-- Initialization
--

function mod:OnBossEnable()
	L = BigWigs.bossCore:GetModule("Sinestra"):GetLocale()

	self:Log("SPELL_CAST_SUCCESS", "Whelp", 92953)
	--self:Log("SPELL_CAST_START", "Breath", 92944)

	--self:RegisterEvent("UNIT_HEALTH")
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")

	self:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT", "CheckBossStatus")

	self:Death("Deaths", 45213, 47265, 48047, 48048, 48049, 48050) -- Sinestra, 5 whelps

end

function mod:OnEngage()
	--spawnBreath = true
	wipe(usedMarks)
	wipe(whelps)
end

--------------------------------------------------------------------------------
-- Event Handlers
--


local function GetAvailableMark()
	for i=1, 5 do
		if not usedMarks[i] then
			return i
		end
	end
	return false
end

local function MarkByGUID(GUID)
	if not GetAvailableMark() then return end
	local mark = GetAvailableMark()

	if not whelps[GUID] then
		local mobId = mod:GetUnitIdByGUID(GUID)
		if mobId then
			SetRaidTarget(mobId, mark)
			whelps[GUID] = mark
			usedMarks[mark] = true
		else
			mod:ScheduleTimer(MarkByGUID, 0.1, GUID)
		end
	end
end

function mod:Deaths(mobId, GUID)
	if mobId == 47265 or mobId == 48047 or mobId == 48048 or mobId == 48049 or mobId == 48050 then
		local mark = whelps[GUID]
		if mark then -- in case something dies thats not marked
			usedMarks[mark] = nil
			--whelps[GUID] = nil
		end
	elseif mobId == 45213 then
		self:Win()
	end
end

function mod:UPDATE_MOUSEOVER_UNIT()
	local unit = "mouseover"
	if not UnitName(unit) or UnitIsCorpse(unit) or UnitIsDead(unit) or UnitPlayerControlled(unit) then return end
	local GUID = UnitGUID(unit)
	local mobId = tonumber(GUID:sub(7, 10), 16)
	if mobId == 47265 or mobId == 48047 or mobId == 48048 or mobId == 48049 or mobId == 48050 then
		MarkByGUID(GUID)
	end
end

function mod:Whelp(_, _, _, _, _, _, _, _, _, _, sGUID)
	MarkByGUID(sGUID)
end

--[[
function mod:Breath()
	if spawnBreath then
		wipe(whelps)
		spawnBreath = nil
	else
		spawnBreath = true
	end
end


function mod:UNIT_HEALTH(event, unit)
	if unit == "boss1" then
		local hp = UnitHealth(unit) / UnitHealthMax(unit) * 100
		if hp <= 30.5 then
			wipe(whelps)
		end
	end
end

]]--